Index: uspace/lib/c/generic/vol.c
===================================================================
--- uspace/lib/c/generic/vol.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/generic/vol.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -39,4 +39,5 @@
 #include <loc.h>
 #include <stdlib.h>
+#include <str.h>
 #include <vol.h>
 
@@ -251,13 +252,48 @@
 }
 
+/** Get volume label support. */
+int vol_part_get_lsupp(vol_t *vol, vol_fstype_t fstype,
+    vol_label_supp_t *vlsupp)
+{
+	async_exch_t *exch;
+	sysarg_t retval;
+	ipc_call_t answer;
+
+	exch = async_exchange_begin(vol->sess);
+	aid_t req = async_send_1(exch, VOL_PART_LSUPP, fstype, &answer);
+	int rc = async_data_read_start(exch, vlsupp, sizeof(vol_label_supp_t));
+	async_exchange_end(exch);
+
+	if (rc != EOK) {
+		async_forget(req);
+		return EIO;
+	}
+
+	async_wait_for(req, &retval);
+	if (retval != EOK)
+		return EIO;
+
+	return EOK;
+}
+
 /** Create file system. */
-int vol_part_mkfs(vol_t *vol, service_id_t sid, vol_fstype_t fstype)
-{
-	async_exch_t *exch;
-	int retval;
-
-	exch = async_exchange_begin(vol->sess);
-	retval = async_req_2_0(exch, VOL_PART_MKFS, sid, fstype);
-	async_exchange_end(exch);
+int vol_part_mkfs(vol_t *vol, service_id_t sid, vol_fstype_t fstype,
+    const char *label)
+{
+	async_exch_t *exch;
+	ipc_call_t answer;
+	sysarg_t retval;
+
+	exch = async_exchange_begin(vol->sess);
+	aid_t req = async_send_2(exch, VOL_PART_MKFS, sid, fstype, &answer);
+	retval = async_data_write_start(exch, label, str_size(label));
+	async_exchange_end(exch);
+
+	if (retval != EOK) {
+		async_forget(req);
+		return retval;
+	}
+
+	async_wait_for(req, &retval);
 
 	if (retval != EOK)
Index: uspace/lib/c/include/adt/hash.h
===================================================================
--- uspace/lib/c/include/adt/hash.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/adt/hash.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 
 #include <stdint.h>
+#include <types/common.h>
 
 /** Produces a uniform hash affecting all output bits from the skewed input. */
Index: uspace/lib/c/include/adt/list.h
===================================================================
--- uspace/lib/c/include/adt/list.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/adt/list.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,4 +40,5 @@
 #include <stdbool.h>
 #include <stddef.h>
+#include <trace.h>
 
 /** Doubly linked list link. */
@@ -51,4 +52,8 @@
 	link_t head;  /**< List head. Does not have any data. */
 } list_t;
+
+extern bool list_member(const link_t *, const list_t *);
+extern void list_splice(list_t *, link_t *);
+extern unsigned long list_count(const list_t *);
 
 /** Declare and initialize statically allocated list.
@@ -88,13 +93,13 @@
 #define list_foreach(list, member, itype, iterator) \
 	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) 1) \
-	    for (link_t *_link = (list).head.next; \
-	    iterator = list_get_instance(_link, itype, member), \
-	    _link != &(list).head; _link = _link->next)
+		for (link_t *_link = (list).head.next; \
+		    iterator = list_get_instance(_link, itype, member), \
+		    _link != &(list).head; _link = _link->next)
 
 #define list_foreach_rev(list, member, itype, iterator) \
 	for (itype *iterator = NULL; iterator == NULL; iterator = (itype *) 1) \
-	    for (link_t *_link = (list).head.prev; \
-	    iterator = list_get_instance(_link, itype, member), \
-	    _link != &(list).head; _link = _link->prev)
+		for (link_t *_link = (list).head.prev; \
+		    iterator = list_get_instance(_link, itype, member), \
+		    _link != &(list).head; _link = _link->prev)
 
 /** Unlike list_foreach(), allows removing items while traversing a list.
@@ -125,7 +130,7 @@
 #define list_foreach_safe(list, iterator, next_iter) \
 	for (link_t *iterator = (list).head.next, \
-		*next_iter = iterator->next; \
-		iterator != &(list).head; \
-		iterator = next_iter, next_iter = iterator->next)
+	    *next_iter = iterator->next; \
+	    iterator != &(list).head; \
+	    iterator = next_iter, next_iter = iterator->next)
 
 #define assert_link_not_used(link) \
@@ -145,5 +150,5 @@
  *
  */
-static inline void link_initialize(link_t *link)
+NO_TRACE static inline void link_initialize(link_t *link)
 {
 	link->prev = NULL;
@@ -158,5 +163,5 @@
  *
  */
-static inline void list_initialize(list_t *list)
+NO_TRACE static inline void list_initialize(list_t *list)
 {
 	list->head.prev = &list->head;
@@ -194,5 +199,5 @@
  *
  */
-static inline void list_prepend(link_t *link, list_t *list)
+NO_TRACE static inline void list_prepend(link_t *link, list_t *list)
 {
 	list_insert_after(link, &list->head);
@@ -207,5 +212,5 @@
  *
  */
-static inline void list_append(link_t *link, list_t *list)
+NO_TRACE static inline void list_append(link_t *link, list_t *list)
 {
 	list_insert_before(link, &list->head);
@@ -220,5 +225,5 @@
  *
  */
-static inline void list_remove(link_t *link)
+NO_TRACE static inline void list_remove(link_t *link)
 {
 	if ((link->prev != NULL) && (link->next != NULL)) {
@@ -237,5 +242,5 @@
  *
  */
-static inline bool list_empty(const list_t *list)
+NO_TRACE static inline bool list_empty(const list_t *list)
 {
 	return (list->head.next == &list->head);
@@ -274,5 +279,4 @@
  *
  * @return Next item or NULL if @a link is the last item.
- *
  */
 static inline link_t *list_next(const link_t *link, const list_t *list)
@@ -287,5 +291,4 @@
  *
  * @return Previous item or NULL if @a link is the first item.
- *
  */
 static inline link_t *list_prev(const link_t *link, const list_t *list)
@@ -307,5 +310,5 @@
  *
  */
-static inline void headless_list_split_or_concat(link_t *part1, link_t *part2)
+NO_TRACE static inline void headless_list_split_or_concat(link_t *part1, link_t *part2)
 {
 	part1->prev->next = part2;
@@ -328,5 +331,5 @@
  *
  */
-static inline void headless_list_split(link_t *part1, link_t *part2)
+NO_TRACE static inline void headless_list_split(link_t *part1, link_t *part2)
 {
 	headless_list_split_or_concat(part1, part2);
@@ -343,7 +346,22 @@
  *
  */
-static inline void headless_list_concat(link_t *part1, link_t *part2)
+NO_TRACE static inline void headless_list_concat(link_t *part1, link_t *part2)
 {
 	headless_list_split_or_concat(part1, part2);
+}
+
+/** Concatenate two lists
+ *
+ * Concatenate lists @a list1 and @a list2, producing a single
+ * list @a list1 containing items from both (in @a list1, @a list2
+ * order) and empty list @a list2.
+ *
+ * @param list1		First list and concatenated output
+ * @param list2 	Second list and empty output.
+ *
+ */
+NO_TRACE static inline void list_concat(list_t *list1, list_t *list2)
+{
+	list_splice(list2, list1->head.prev);
 }
 
@@ -396,8 +414,4 @@
 }
 
-extern bool list_member(const link_t *, const list_t *);
-extern void list_concat(list_t *, list_t *);
-extern unsigned long list_count(const list_t *);
-
 #endif
 
Index: uspace/lib/c/include/as.h
===================================================================
--- uspace/lib/c/include/as.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/as.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,5 +36,5 @@
 #define LIBC_AS_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 #include <stddef.h>
 #include <stdint.h>
Index: uspace/lib/c/include/async.h
===================================================================
--- uspace/lib/c/include/async.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/async.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -166,7 +166,7 @@
     sysarg_t, async_port_handler_t, void *, port_id_t *);
 
-extern int async_irq_subscribe(int, int, async_notification_handler_t, void *,
+extern int async_irq_subscribe(int, async_notification_handler_t, void *,
     const irq_code_t *);
-extern int async_irq_unsubscribe(int, int);
+extern int async_irq_unsubscribe(int);
 
 extern int async_event_subscribe(event_type_t, async_notification_handler_t,
@@ -343,5 +343,4 @@
     sysarg_t *, sysarg_t *);
 
-extern async_sess_t *async_clone_establish(exch_mgmt_t, async_exch_t *);
 extern async_sess_t *async_connect_me_to(exch_mgmt_t, async_exch_t *, sysarg_t,
     sysarg_t, sysarg_t);
@@ -472,6 +471,4 @@
     sysarg_t, sysarg_t, sysarg_t, ipc_call_t *);
 
-extern int async_exchange_clone(async_exch_t *, async_exch_t *);
-extern async_sess_t *async_clone_receive(exch_mgmt_t);
 extern async_sess_t *async_callback_receive(exch_mgmt_t);
 extern async_sess_t *async_callback_receive_start(exch_mgmt_t, ipc_call_t *);
Index: uspace/lib/c/include/atomicdflt.h
===================================================================
--- uspace/lib/c/include/atomicdflt.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/atomicdflt.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,5 +40,5 @@
 #endif
 
-#include <stdint.h>
+#include <types/common.h>
 #include <stdbool.h>
 
Index: uspace/lib/c/include/bd.h
===================================================================
--- uspace/lib/c/include/bd.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/bd.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,5 @@
 
 #include <async.h>
-#include <sys/types.h>
+#include <offset.h>
 
 typedef struct {
Index: uspace/lib/c/include/bd_srv.h
===================================================================
--- uspace/lib/c/include/bd_srv.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/bd_srv.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,5 +40,5 @@
 #include <fibril_synch.h>
 #include <stdbool.h>
-#include <sys/types.h>
+#include <offset.h>
 
 typedef struct bd_ops bd_ops_t;
Index: uspace/lib/c/include/cap.h
===================================================================
--- uspace/lib/c/include/cap.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/cap.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2006 Jakub Jermar
+ * Copyright (c) 2015 Jiri Svoboda
  * All rights reserved.
  *
@@ -30,14 +30,69 @@
  * @{
  */
-/** @file
+/**
+ * @file Storage capacity specification.
  */
 
-#ifndef LIB_CAP_H_
-#define LIB_CAP_H_
+#ifndef LIBC_CAP_H_
+#define LIBC_CAP_H_
 
-#include <task.h>
+#include <adt/list.h>
+#include <loc.h>
+#include <stdint.h>
+#include <types/label.h>
+#include <types/vol.h>
+#include <vbd.h>
 
-extern int cap_grant(task_id_t id, unsigned int caps);
-extern int cap_revoke(task_id_t id, unsigned int caps);
+/** Capacity unit */
+typedef enum {
+	cu_byte = 0,
+	cu_kbyte,
+	cu_mbyte,
+	cu_gbyte,
+	cu_tbyte,
+	cu_pbyte,
+	cu_ebyte,
+	cu_zbyte,
+	cu_ybyte
+} cap_unit_t;
+
+/** Which of values within the precision of the capacity */
+typedef enum {
+	/** The nominal (middling) value */
+	cv_nom,
+	/** The minimum value */
+	cv_min,
+	/** The maximum value */
+	cv_max
+} cap_vsel_t;
+
+#define CU_LIMIT (cu_ybyte + 1)
+
+/** Storage capacity.
+ *
+ * Storage capacity represents both value and precision.
+ * It is a decimal floating point value combined with a decimal
+ * capacity unit. There is an integer mantisa @c m which in combination
+ * with the number of decimal positions @c dp gives a decimal floating-point
+ * number. E.g. for m = 1025 and dp = 2 the number is 10.25. If the unit
+ * cunit = cu_kbyte, the capacity is 10.25 kByte, i.e. 10 250 bytes.
+ *
+ * Note that 1.000 kByte is equivalent to 1000 Byte, but 1 kByte is less
+ * precise.
+ */
+typedef struct {
+	/** Mantisa */
+	uint64_t m;
+	/** Decimal positions */
+	unsigned dp;
+	/** Capacity unit */
+	cap_unit_t cunit;
+} cap_spec_t;
+
+extern int cap_format(cap_spec_t *, char **);
+extern int cap_parse(const char *, cap_spec_t *);
+extern void cap_simplify(cap_spec_t *);
+extern void cap_from_blocks(uint64_t, size_t, cap_spec_t *);
+extern int cap_to_blocks(cap_spec_t *, cap_vsel_t, size_t, uint64_t *);
 
 #endif
Index: uspace/lib/c/include/corecfg.h
===================================================================
--- uspace/lib/c/include/corecfg.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/corecfg.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,6 +33,6 @@
  */
 
-#ifndef LIBC_INET_INETCFG_H_
-#define LIBC_INET_INETCFG_H_
+#ifndef LIBC_CORECFG_H_
+#define LIBC_CORECFG_H_
 
 #include <stdbool.h>
Index: uspace/lib/c/include/device/hw_res.h
===================================================================
--- uspace/lib/c/include/device/hw_res.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/device/hw_res.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -52,4 +52,6 @@
 	HW_RES_GET_RESOURCE_LIST = 0,
 	HW_RES_ENABLE_INTERRUPT,
+	HW_RES_DISABLE_INTERRUPT,
+	HW_RES_CLEAR_INTERRUPT,
 	HW_RES_DMA_CHANNEL_SETUP,
 	HW_RES_DMA_CHANNEL_REMAIN,
@@ -115,5 +117,7 @@
 
 extern int hw_res_get_resource_list(async_sess_t *, hw_resource_list_t *);
-extern bool hw_res_enable_interrupt(async_sess_t *);
+extern int hw_res_enable_interrupt(async_sess_t *, int);
+extern int hw_res_disable_interrupt(async_sess_t *, int);
+extern int hw_res_clear_interrupt(async_sess_t *, int);
 
 extern int hw_res_dma_channel_setup(async_sess_t *, unsigned int, uint32_t,
Index: uspace/lib/c/include/dirent.h
===================================================================
--- uspace/lib/c/include/dirent.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/dirent.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,5 @@
 #define NAME_MAX  256
 
-#include <sys/types.h>
+#include <offset.h>
 
 struct dirent {
Index: uspace/lib/c/include/elf/elf.h
===================================================================
--- uspace/lib/c/include/elf/elf.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/elf/elf.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,5 @@
 
 #include <stdint.h>
-#include <libarch/types.h>
+#include <types/common.h>
 #include <abi/elf.h>
 #include <libarch/elf.h>
Index: uspace/lib/c/include/fibril.h
===================================================================
--- uspace/lib/c/include/fibril.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/fibril.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,5 @@
 
 #include <libarch/fibril.h>
+#include <types/common.h>
 #include <adt/list.h>
 #include <libarch/tls.h>
Index: uspace/lib/c/include/fibril_synch.h
===================================================================
--- uspace/lib/c/include/fibril_synch.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/fibril_synch.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -173,4 +173,6 @@
 extern fibril_timer_state_t fibril_timer_clear(fibril_timer_t *);
 extern fibril_timer_state_t fibril_timer_clear_locked(fibril_timer_t *);
+extern void fibril_usleep(useconds_t);
+extern void fibril_sleep(unsigned int);
 
 #endif
Index: uspace/lib/c/include/fourcc.h
===================================================================
--- uspace/lib/c/include/fourcc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/include/fourcc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,45 @@
+/*
+ * Copyright (c) 2017 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_FOURCC_H_
+#define LIBC_FOURCC_H_
+
+#include <stdint.h>
+
+typedef uint32_t fourcc_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/gsort.h
===================================================================
--- uspace/lib/c/include/gsort.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/include/gsort.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2005 Sergey Bondari
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_SORT_H_
+#define LIBC_SORT_H_
+
+#include <stddef.h>
+#include <stdbool.h>
+
+typedef int (* sort_cmp_t)(void *, void *, void *);
+
+extern bool gsort(void *, size_t, size_t, sort_cmp_t, void *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/inet/dhcp.h
===================================================================
--- uspace/lib/c/include/inet/dhcp.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/inet/dhcp.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,5 @@
 #define LIBC_INET_DHCP_H_
 
+#include <types/common.h>
 
 extern int dhcp_init(void);
Index: uspace/lib/c/include/inet/udp.h
===================================================================
--- uspace/lib/c/include/inet/udp.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/inet/udp.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -95,4 +95,5 @@
 extern int udp_assoc_create(udp_t *, inet_ep2_t *, udp_cb_t *, void *,
     udp_assoc_t **);
+extern int udp_assoc_set_nolocal(udp_assoc_t *);
 extern void udp_assoc_destroy(udp_assoc_t *);
 extern int udp_assoc_send_msg(udp_assoc_t *, inet_ep_t *, void *, size_t);
Index: uspace/lib/c/include/io/chardev.h
===================================================================
--- uspace/lib/c/include/io/chardev.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/io/chardev.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -33,5 +33,5 @@
 #define LIBC_IO_CHARDEV_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 #include <async.h>
 
Index: uspace/lib/c/include/io/chargrid.h
===================================================================
--- uspace/lib/c/include/io/chargrid.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/io/chargrid.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,6 +37,7 @@
 #define LIBC_IO_CHARGRID_H_
 
+#include <io/charfield.h>
+#include <types/common.h>
 #include <stddef.h>
-#include <io/charfield.h>
 
 typedef enum {
Index: uspace/lib/c/include/io/log.h
===================================================================
--- uspace/lib/c/include/io/log.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/io/log.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,5 +38,5 @@
 #include <inttypes.h>
 #include <io/verify.h>
-#include <libarch/types.h>
+#include <types/common.h>
 
 #include <abi/log.h>
Index: uspace/lib/c/include/io/pixelmap.h
===================================================================
--- uspace/lib/c/include/io/pixelmap.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/io/pixelmap.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,6 @@
 #define LIBC_IO_PIXELMAP_H_
 
+#include <types/common.h>
+#include <stdbool.h>
 #include <stddef.h>
 #include <io/pixel.h>
Index: uspace/lib/c/include/io/pos_event.h
===================================================================
--- uspace/lib/c/include/io/pos_event.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/io/pos_event.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,5 @@
 #define LIBC_IO_POS_EVENT_H_
 
+#include <types/common.h>
 
 typedef enum {
Index: uspace/lib/c/include/io/table.h
===================================================================
--- uspace/lib/c/include/io/table.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/lib/c/include/io/table.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,110 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libc
+ * @{
+ */
+/** @file
+ */
+
+#ifndef LIBC_IO_TABLE_H_
+#define LIBC_IO_TABLE_H_
+
+#include <adt/list.h>
+#include <stdbool.h>
+#include <stddef.h>
+#include <stdio.h>
+
+/** Table metrics */
+typedef struct {
+	/** Space to the left of the table */
+	size_t margin_left;
+} table_metrics_t;
+
+/** Table cell */
+typedef struct {
+	/** Containing row */
+	struct table_row *row;
+	/** Link to table_row_t.cells */
+	link_t lrow;
+	/** Cell text */
+	char *text;
+} table_cell_t;
+
+/** Table row */
+typedef struct table_row {
+	/** Containing table */
+	struct table *table;
+	/** Link to table_t.rows */
+	link_t ltable;
+	/** Cells of this row */
+	list_t cells;
+} table_row_t;
+
+/** Table column */
+typedef struct {
+	/** Containing table */
+	struct table *table;
+	/** Link to table_t.columns */
+	link_t ltable;
+	/** Column width */
+	size_t width;
+} table_column_t;
+
+/** Table */
+typedef struct table {
+	/** @c true if the first row is a header row */
+	bool header_row;
+	/** Encountered error while writing to table */
+	int error;
+	/** Table rows */
+	list_t rows; /* of table_row_t */
+	/** Table columns */
+	list_t columns; /* of table_column_t */
+	/** Current row */
+	table_row_t *wrow;
+	/** Current cell */
+	table_cell_t *wcell;
+	/** Current column */
+	table_column_t *wcolumn;
+	/** Table metrics */
+	table_metrics_t metrics;
+} table_t;
+
+extern int table_create(table_t **);
+extern void table_destroy(table_t *);
+extern int table_print_out(table_t *, FILE *);
+extern void table_header_row(table_t *);
+extern int table_printf(table_t *, const char *, ...);
+extern int table_get_error(table_t *);
+extern void table_set_margin_left(table_t *, size_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/c/include/ipc/dev_iface.h
===================================================================
--- uspace/lib/c/include/ipc/dev_iface.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/ipc/dev_iface.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -31,5 +31,5 @@
 
 #include <malloc.h>
-#include <libarch/types.h>
+#include <types/common.h>
 
 typedef enum {
Index: uspace/lib/c/include/ipc/event.h
===================================================================
--- uspace/lib/c/include/ipc/event.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/ipc/event.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,5 +37,5 @@
 
 #include <abi/ipc/event.h>
-#include <libarch/types.h>
+#include <types/common.h>
 
 extern int ipc_event_subscribe(event_type_t, sysarg_t);
Index: uspace/lib/c/include/ipc/irc.h
===================================================================
--- uspace/lib/c/include/ipc/irc.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/ipc/irc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,4 +40,5 @@
 typedef enum {
 	IRC_ENABLE_INTERRUPT = IPC_FIRST_USER_METHOD,
+	IRC_DISABLE_INTERRUPT,
 	IRC_CLEAR_INTERRUPT
 } irc_request_t;
Index: uspace/lib/c/include/ipc/irq.h
===================================================================
--- uspace/lib/c/include/ipc/irq.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/ipc/irq.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,9 +36,9 @@
 #define LIBC_IPC_IRQ_H_
 
-#include <libarch/types.h>
+#include <types/common.h>
 #include <abi/ddi/irq.h>
 
-extern int ipc_irq_subscribe(int, int, sysarg_t, const irq_code_t *);
-extern int ipc_irq_unsubscribe(int, int);
+extern int ipc_irq_subscribe(int, sysarg_t, const irq_code_t *);
+extern int ipc_irq_unsubscribe(int);
 
 #endif
Index: uspace/lib/c/include/ipc/ns.h
===================================================================
--- uspace/lib/c/include/ipc/ns.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/ipc/ns.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -40,4 +40,5 @@
 typedef enum {
 	NS_PING = IPC_FIRST_USER_METHOD,
+	NS_REGISTER,
 	NS_TASK_WAIT,
 	NS_ID_INTRO,
Index: uspace/lib/c/include/ipc/services.h
===================================================================
--- uspace/lib/c/include/ipc/services.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/ipc/services.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -47,8 +47,7 @@
 	SERVICE_LOGGER     = FOURCC('l', 'o', 'g', 'g'),
 	SERVICE_DEVMAN     = FOURCC('d', 'e', 'v', 'n'),
-	SERVICE_IRC        = FOURCC('i', 'r', 'c', ' '),
-	SERVICE_CLIPBOARD  = FOURCC('c', 'l', 'i', 'p'),
 } service_t;
 
+#define SERVICE_NAME_CLIPBOARD "clipboard"
 #define SERVICE_NAME_CORECFG  "corecfg"
 #define SERVICE_NAME_DHCP     "net/dhcp"
Index: uspace/lib/c/include/ipc/udp.h
===================================================================
--- uspace/lib/c/include/ipc/udp.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/ipc/udp.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -42,4 +42,5 @@
 	UDP_ASSOC_CREATE,
 	UDP_ASSOC_DESTROY,
+	UDP_ASSOC_SET_NOLOCAL,
 	UDP_ASSOC_SEND_MSG,
 	UDP_RMSG_INFO,
Index: uspace/lib/c/include/ipc/vol.h
===================================================================
--- uspace/lib/c/include/ipc/vol.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/ipc/vol.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -36,4 +36,6 @@
 #include <ipc/common.h>
 
+#define VOL_LABEL_MAXLEN 63
+
 typedef enum {
 	VOL_GET_PARTS = IPC_FIRST_USER_METHOD,
@@ -41,5 +43,6 @@
 	VOL_PART_INFO,
 	VOL_PART_EMPTY,
-	VOL_PART_MKFS
+	VOL_PART_LSUPP,
+	VOL_PART_MKFS,
 } vol_request_t;
 
Index: uspace/lib/c/include/irc.h
===================================================================
--- uspace/lib/c/include/irc.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/irc.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
 extern int irc_enable_interrupt(int);
 extern int irc_disable_interrupt(int);
+extern int irc_clear_interrupt(int);
 
 #endif
Index: uspace/lib/c/include/ns.h
===================================================================
--- uspace/lib/c/include/ns.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/lib/c/include/ns.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -46,4 +46,5 @@
 extern int ns_ping(void);
 extern int ns_intro(task_id_t);
+extern async_sess_t *ns_session_get(void);
 
 #endif
